<template>
  <ContentWrap>
    <!-- 搜索工作栏 -->
    <el-form
      class="-mb-15px"
      :model="queryParams"
      ref="queryFormRef"
      :inline="true"
      label-width="68px"
    >
      <el-form-item label="供应商" prop="supplierId" v-if="ifAlone==null">
        <el-input
          v-model="queryParams.supplierId"
          placeholder="请输入供应商"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="证件类型" label-width="85px" prop="type">
        <el-select v-model="queryParams.type" placeholder="证件类型" clearable class="!w-240px">
          <el-option
            v-for="dict in getIntDictOptions(DICT_TYPE.SUPPLIER_CERT)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="证件名称" prop="name">
        <el-input
          v-model="queryParams.name"
          placeholder="请输入证件名称"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <!--      <el-form-item label="创建时间" prop="createTime">-->
      <!--        <el-date-picker-->
      <!--          v-model="queryParams.createTime"-->
      <!--          value-format="YYYY-MM-DD HH:mm:ss"-->
      <!--          type="daterange"-->
      <!--          start-placeholder="开始日期"-->
      <!--          end-placeholder="结束日期"-->
      <!--          :default-time="[new Date('1 00:00:00'), new Date('1 23:59:59')]"-->
      <!--          class="!w-220px"-->
      <!--        />-->
      <!--      </el-form-item>-->
      <el-form-item>
        <el-button @click="handleQuery"><Icon icon="ep:search" class="mr-5px" /> 搜索</el-button>
        <el-button @click="resetQuery"><Icon icon="ep:refresh" class="mr-5px" /> 重置</el-button>
        <el-button v-if="!isDetail" type="primary" plain @click="openForm('create')">
          <Icon icon="ep:plus" class="mr-5px" /> 新增
        </el-button>
        <el-button
          v-if="!isDetail"
          type="success"
          plain
          @click="handleExport"
          :loading="exportLoading"
        >
          <Icon icon="ep:download" class="mr-5px" /> 导出
        </el-button>
      </el-form-item>
    </el-form>
  </ContentWrap>

  <!-- 列表 -->
  <ContentWrap>
    <el-table v-loading="loading" :data="list" :stripe="true" :show-overflow-tooltip="true">
      <!--      <el-table-column label="主键" align="center" prop="id" />-->
      <el-table-column label="供应商" align="center" prop="supplierId">
        <template #default="scope">
          <span>{{ supplierList.find((item) => item.id === scope.row.supplierId)?.name }}</span>
        </template>
      </el-table-column>
      <el-table-column label="证件类型" align="center" prop="type">
        <template #default="scope">
          <dict-tag :type="DICT_TYPE.SUPPLIER_CERT" :value="scope.row.type" />
        </template>
      </el-table-column>
      <el-table-column label="证件名称" align="center" prop="name" />
      <el-table-column
        label="创建时间"
        align="center"
        prop="createTime"
        :formatter="dateFormatter"
        width="180px"
      />
      <el-table-column label="附件" align="center" prop="urls">
        <!--          <template #default="scope">-->

        <!--            <el-button @click="openView(scope.row)">-->
        <!--              <Icon style="color: #14c4ca" icon="ep:view"/>-->
        <!--            </el-button>-->
        <!--          </template>-->
        <template #default="scope">
          <el-button link type="primary" @click="openView(scope.row)"> 查看 </el-button>
        </template>
      </el-table-column>
      <el-table-column v-if="!isDetail" label="操作" align="center" min-width="120px">
        <template #default="scope">
          <el-button link type="primary" @click="openForm('update', scope.row.id)">
            编辑
          </el-button>
          <el-button link type="danger" @click="handleDelete(scope.row.id)"> 删除 </el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页 -->
    <Pagination
      :total="total"
      v-model:page="queryParams.pageNo"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </ContentWrap>

  <!-- 表单弹窗：添加/修改 -->
  <CertificateForm
    ref="formRef"
    :supplierId="{ receivedParam }"
    :ifAlone="ifAlone"
    @success="getList"
  />
  <el-form v-if="ifAlone != null">
    <el-form-item style="float: right">
      <el-button @click="close" type="primary">返回</el-button>
    </el-form-item>
  </el-form>

  <el-dialog
    title="预览文件"
    v-model="showDialog"
    width="900px"
    height="700px"
    style="min-height: 200px"
    destroy-on-close
  >
    <el-row>
      <el-table
        :data="objectInfo"
        size="small"
        border
        header-cell-class-name="table-header-gray"
      >
        <el-table-column
          label="文件名称"
          prop="name"
          min-width="100"
          align="center"
        />
        <el-table-column
          label="预览"
          prop="url"
          min-width="100"
          align="center"
        >
                    <template #default="scope">
                      <el-button @click="openWeb(scope.row.url)" style="border: none">
                        <Icon style="color: #14c4ca" icon="ep:view"/>
                      </el-button>
                    </template>
        </el-table-column>
      </el-table>
    </el-row>
  </el-dialog>
</template>

<script setup lang="ts">
import { dateFormatter } from '@/utils/formatTime'
import download from '@/utils/download'
import { CertificateApi, CertificateVO } from '@/api/supplier/certificate'
import CertificateForm from './CertificateForm.vue'
import { DICT_TYPE, getIntDictOptions } from '@/utils/dict'
import * as SupplierBaseApi from '@/api/supplier/base'
import { SupplierVO } from '@/api/supplier/base'
import { propTypes } from '@/utils/propTypes'
import { useTagsViewStore } from '@/store/modules/tagsView'

const { delView } = useTagsViewStore() // 视图操作
const { push, currentRoute } = useRouter() // 路由
const showDialog = ref(false)
/** 供应商证件资质 列表 */
defineOptions({ name: 'SupplierCertificate' })
const supplierList = ref([] as SupplierVO[])
const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化
const props = defineProps({
  isDetail: propTypes.bool.def(false), // 是否作为详情组件
  ifAlone: { type: Boolean, default: () => null },
  receivedParam: { type: undefined, default: () => null }
})
const loading = ref(true) // 列表的加载中
const list = ref<CertificateVO[]>([]) // 列表的数据
const total = ref(0) // 列表的总页数
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  supplierId: undefined,
  supplierName: undefined,
  type: undefined,
  name: undefined,
  urls: undefined,
  createTime: []
})
const queryFormRef = ref() // 搜索的表单
const exportLoading = ref(false) // 导出的加载中
const objectInfo = ref([])
const openView = (row: CertificateVO) => {
  if (row.urls) {
    objectInfo.value=[]
    row.urls.split(',').forEach(item => {
      let object = {url:'',name:''};
      object.url = item;
      const lastIndex = item.lastIndexOf('/');
      object.name = lastIndex !== -1 ? item.substring(lastIndex+1) : item;
      objectInfo.value.push(object);
    })
  }
  showDialog.value = true
}
const openWeb = (url) => {
  window.open('http://1.94.244.160:8012/onlinePreview?url='+encodeURIComponent(Base64.encode(url)));
}

const getList = async () => {
  supplierList.value = await SupplierBaseApi.Api.getAll()
  loading.value = true
  try {
    if (props.ifAlone != null) {
      queryParams.supplierId = props.receivedParam === null ? '0000000000' : props.receivedParam
    }
    const data = await CertificateApi.getCertificatePage(queryParams)
    list.value = data.list
    total.value = data.total
    queryParams.supplierId = undefined
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = async () => {
  queryParams.pageNo = 1
  await getList()
  supplierList.value = await SupplierBaseApi.Api.getAll()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
  formRef.value.open(type, id)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await CertificateApi.deleteCertificate(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

/** 导出按钮操作 */
const handleExport = async () => {
  try {
    // 导出的二次确认
    await message.exportConfirm()
    // 发起导出
    exportLoading.value = true
    const data = await CertificateApi.exportCertificate(queryParams)
    download.excel(data, '供应商证件资质.xls')
  } catch {
  } finally {
    exportLoading.value = false
  }
}

/** 初始化 **/
onMounted(async () => {
  await getList()
  supplierList.value = await SupplierBaseApi.Api.getAll()
})
const close = () => {
  delView(unref(currentRoute))
  push({
    name: 'Suppliers',
    query: {
      date: new Date().getTime()
    }
  })
}
</script>
